const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of employeeGrades by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} employeeGrades - The array of employeeGrades to format.
 * @returns {Promise<Object[]>} - The formatted array of employeeGrades.
 */
const formatWithModifier = async (employeeGrades) => {
    return Promise.all(
        employeeGrades.map(async (employeeGrade) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: employeeGrade.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...employeeGrade,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all employeeGrades with their parent employeeGrade title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.employeeGradesId - The ids of the employeeGrades to retrieve.
 * @returns {Promise<Object>} - The response object with the employeeGrades and success status.
 */
async function getAll(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        let employeeGrades = []
        employeeGrades = await dbSAPPS.EmployeeGrade.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'name', 'display_name']
                }
            ],
        });

        employeeGrades = employeeGrades.map(employeeGrade => {
            return {
                ...employeeGrade.dataValues,
                company_name: employeeGrade?.company?.display_name
            }
        });

        employeeGrades = await formatWithModifier(employeeGrades);

        return {
            employeeGrades,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get employeeGrade items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the employeeGrade items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the employeeGrade items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the employeeGrade items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        let options = [];
        options = await dbSAPPS.EmployeeGrade.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'name', 'display_name']
                }
            ],
        });

        options = options.map(option => {
            return {
                ...option.dataValues,
                company_name: option?.company?.display_name
            }
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active employeeGrade items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.EmployeeGrade.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new employeeGrade item.
 * 
 * @param {Object} params - The new employeeGrade item data.
 * @param {string} params.name - The name of the employeeGrade item.
 * @param {string} params.title - The title of the employeeGrade item.
 * @param {number} [params.parent_id] - The ID of the parent employeeGrade item.
 * @param {string} [params.url] - The URL of the employeeGrade item.
 * @param {string} [params.icon] - The icon of the employeeGrade item.
 * @param {string} [params.type=link] - The type of the employeeGrade item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the employeeGrade item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the employeeGrade item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the employeeGrade item.
 * @param {number} [params.owner=1] - The ID of the user who created the employeeGrade item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the employeeGrade item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the employeeGrade item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.EmployeeGrade.findOne({
            where: {
                name: params.name,
                display_name: params.display_name,
                company_id: params.company_id,
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.EmployeeGrade.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing employeeGrade item.
 * 
 * @param {number} id - The ID of the employeeGrade item to update.
 * @param {Object} params - The updated employeeGrade item data.
 * @param {string} [params.name] - The new name of the employeeGrade item.
 * @param {string} [params.title] - The new title of the employeeGrade item.
 * @param {number} [params.parent_id] - The new parent ID of the employeeGrade item.
 * @param {string} [params.url] - The new URL of the employeeGrade item.
 * @param {string} [params.icon] - The new icon of the employeeGrade item.
 * @param {string} [params.type] - The new type of the employeeGrade item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the employeeGrade item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the employeeGrade item.
 * @param {number} [params.modified] - The new last modification timestamp of the employeeGrade item.
 * @param {number} [params.owner] - The new ID of the user who created the employeeGrade item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the employeeGrade item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the employeeGrade item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const employeeGrade = await dbSAPPS.EmployeeGrade.findByPk(id);
        if (!employeeGrade) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.EmployeeGrade.findOne({
            where: {
                name: params.name,
                display_name: params.display_name,
                company_id: params.company_id,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await employeeGrade.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a employeeGrade
 * @param {number} id - the id of the employeeGrade
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const employeeGrade = await dbSAPPS.EmployeeGrade.findByPk(id);
        if (!employeeGrade) return { success: false, message: 'ID not found!' };

        // delete
        await employeeGrade.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
